Subject: Re: Fw: ipsec hang

From: Patrick McHardy <[email-masked]>
Date: Tue, 30 Nov 2004 00:54:39 +0100

Bill Crowell wrote:

> Re the bk12, is there just 1 patch that I should install to 2.6.10-rc2 
> to test IPSec? If I don't fiddle with the mm code, we might be able to 
> make some progress on this part. I just love simultaneous equations 
> with 1000 or more variables... ;-)

Patch is attached.

Regards
Patrick

# This is a BitKeeper generated diff -Nru style patch.
#
# ChangeSet
#   2004/11/23 18:21:09-08:00 [email-masked] 
#   [XFRM]: Fix endless loop in xfrm_policy_insert
#   
#   The patch 'Fix policy update bug when increasing
#   priority of last policy' broke this, when a policy
#   with lower priority than an existing policy is inserted
#   xfrm_policy_insert loops forever.
#   
#   Signed-off-by: Patrick McHardy <[email-masked]>
#   Signed-off-by: David S. Miller <[email-masked]>
# 
# net/xfrm/xfrm_policy.c
#   2004/11/23 18:20:49-08:00 [email-masked] +1 -0
#   [XFRM]: Fix endless loop in xfrm_policy_insert
#   
#   The patch 'Fix policy update bug when increasing
#   priority of last policy' broke this, when a policy
#   with lower priority than an existing policy is inserted
#   xfrm_policy_insert loops forever.
#   
#   Signed-off-by: Patrick McHardy <[email-masked]>
#   Signed-off-by: David S. Miller <[email-masked]>
# 
diff -Nru a/net/xfrm/xfrm_policy.c b/net/xfrm/xfrm_policy.c
--- a/net/xfrm/xfrm_policy.c	2004-11-30 00:51:18 +01:00
+++ b/net/xfrm/xfrm_policy.c	2004-11-30 00:51:18 +01:00
@@ -353,6 +353,7 @@
 			newpos = p;
 		if (delpol)
 			break;
+		p = &pol->next;
 	}
 	if (newpos)
 		p = newpos;